/* ******************************************************************************
 ATTRIBUTE PURPOSE: 
 1. Base Attribute to clean and prep the raw wiki vertexes (page titles).
***************************************************************************************** */

import WikipediaStats,Std;

rRawWikiTitles := 
  record
    varstring Title {maxlength(1024)};
  end;

RawWikiTitles := dataset('~wikipedia::titles-sorted', rRawWikiTitles,csv(separator([' '])));

rWikiTitles := 
  record
	  unsigned4 Id := 0;
	  RawWikiTitles.Title;
	end;

WikiTitlesPrep := project(RawWikiTitles, transform(rWikiTitles, self := left));

rWikiTitles tWikiTitles(WikiTitlesPrep l, WikiTitlesPrep r) := 
  transform
	  self.Id := l.Id + 1;
		self.Title := r.Title;
	end;
	
WikiTitles := iterate(WikiTitlesPrep, tWikiTitles(left, right));

export PageVertexes := WikiTitles;