﻿import WikipediaStats;
dEdges := WikipediaStats.PageEdges;
count(dEdges); 

dVertexes := WikipediaStats.PageVertexes;
count(dVertexes); 


// Which pages have the most number of outbound links. 
dEdge1 := table(sort(dEdges, fromid, toid), {fromid, pagelinksto_count := count(group)}, fromid); 
dEdge1WithName := join(topn(dEdge1, 200, -pagelinksto_count), dVertexes, left.fromid=right.id, transform({right.title, recordof(left)}, self := left, self := right), hash); 
output(dEdge1WithName); 

// Which pages have the most number of inbound links. 
dEdge2 := table(sort(dEdges, toid, fromid), {toid, pagelinksto_count := count(group)}, fromid); 
dEdge2WithName := join(topn(dEdge2, 200, -pagelinksto_count), dVertexes, left.toid=right.id, transform({right.title, recordof(left)}, self := left, self := right), hash); 
output(dEdge2WithName); 

// join to reverse of self to see which links are bidirectional 
dBiEdges := join(dEdges, dEdges, left.fromid=right.toid and left.toid=right.fromid, transform(recordof(left), self := left), hash); 
dBiEdgesCount := table(sort(dBiEdges, fromid), {fromid, bidirectionallinkcount := count(group)}, fromid); 
dBiEdgesCountWithName := join(topn(dBiEdgesCount, 100, -bidirectionallinkcount), dVertexes, left.fromid=right.id, transform({right.title, recordof(left)}, self := left, self := right), hash); 
output(sort(dBiEdgesCountWithName,-bidirectionallinkcount) );
