﻿/* ******************************************************************************
 ATTRIBUTE PURPOSE: 
 1. Base Attribute to clean and prep the wiki links rows into edges Link A -> Link B format.
***************************************************************************************** */

IMPORT WikipediaStats, Std;

wikilinks_rec := RECORD
  varstring links {maxlength(1024)};
END;

wikilinks_ds := DATASET('~wikipedia::links-simple-sorted', wikilinks_rec,CSV);

wikilinks_from_rec := record
  unsigned4 FromId;
  wikilinks_ds.links;
	unsigned4 ToLinkCount;
end;

wikilinks_from_rec to_wikilinks_from_rec(wikilinks_ds l) := transform
  SET OF STRING linkset := Std.Str.SplitWords(l.links, ':');
  self.FromId := (unsigned4)linkset[1];
	self.links := linkset[2];
	self.ToLinkCount := Std.Str.CountWords(linkset[2], ' ');
end;

export _fileRawPageEdges := PROJECT(wikilinks_ds, to_wikilinks_from_rec(LEFT));

